// DynaHapticView.cpp : CDynaHapticView NX̓̒`s܂B
//

#include "stdafx.h"

#include "DynaHaptic.h"
#include "DynaHapticDoc.h"
#include "DynaHapticView.h"
#include "HisConfig.h"

#include <Physics/PHSolid.h>
#include <Graphics/GRCamera.h>
#include <ImpD3D/D3FileDoc.h>
#include <ImpD3D/D3DocNode.h>
#include <GraphicsGL/GLRenderWgl.h>
#include <WinBasis/WBPath.h>
//	for haptics
#include <WinBasis/WBMMTimer.h>
#include <WinBasis/WBPreciseTimer.h>
#include <Device/DRUsb20Simple.h>
#include <Device/DRUsb20Sh4.h>

//	for shooting
#include <Graphics/GRSphere.h>
#include <Collision/CDSphere.h>
#include <Collision/CDCollisionEngine.h>
#include <Physics/PHForceField.h>
#include <Physics/PHContactEngine.h>

#include <string.h>
#include <fstream>
#include <sstream>
#include <strstream>
using namespace Spr;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int totalTime;
namespace Spr{
extern int detectTime;
extern int analyzeTime;
extern int refTime;
extern int fricTime;
};

enum {
	TIMER_SIMU = 1,
	TIMER_DRAW,
};
static float simuTimerPeriod = 0.033f;

/////////////////////////////////////////////////////////////////////////////
// CDynaHapticView

IMPLEMENT_DYNCREATE(CDynaHapticView, CView)

BEGIN_MESSAGE_MAP(CDynaHapticView, CView)
	//{{AFX_MSG_MAP(CDynaHapticView)
	ON_WM_KEYDOWN()
	ON_WM_ERASEBKGND()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_COMMAND(RENDER_D3D, OnD3d)
	ON_COMMAND(WGL_RENDER, OnGL)
	ON_COMMAND(ID_HIS_CONFIG, OnHisConfig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CDynaHapticView NX̍\z/

CDynaHapticView::CDynaHapticView()
{
	// SPIDAȐs
	bPause = false;
	ReadRegistry();
	WriteRegistry();
	InitHis(std::string(dlConfig.hisList), dlConfig.posScale, dlConfig.forceScale);
	timer.Resolution(dlConfig.timeStep*1000);
	timer.Interval(dlConfig.timeStep*1000);
}

void CDynaHapticView::ReadRegistry(){

	dlConfig.hisList = AfxGetApp()->GetProfileString("his_config", "his_list", "Spidar4\r\nSpidar4 reverse\r\nSpidar4Angers\r\nSpidar4Angers reverse\r\nMouse");
	std::string hisPs(AfxGetApp()->GetProfileString("his_config", "his_posScale", "1.0"));
	std::string hisFs(AfxGetApp()->GetProfileString("his_config", "his_forceScale", "1.0"));
	std::string timeStep(AfxGetApp()->GetProfileString("his_config", "his_timeStep", "0.005"));
	std::istringstream(hisPs) >> dlConfig.posScale;
	std::istringstream(hisFs) >> dlConfig.forceScale;
	std::istringstream(timeStep) >> dlConfig.timeStep;
}
void CDynaHapticView::WriteRegistry(){
	AfxGetApp()->WriteProfileString("his_config", "his_list", dlConfig.hisList);
	char buf[256];
	std::ostrstream(buf, sizeof(buf)) << dlConfig.posScale << '\0';
	AfxGetApp()->WriteProfileString("his_config", "his_posScale", buf);
	std::ostrstream(buf, sizeof(buf)) << dlConfig.forceScale << '\0';
	AfxGetApp()->WriteProfileString("his_config", "his_forceScale", buf);
	std::ostrstream(buf, sizeof(buf)) << dlConfig.timeStep << '\0';
	AfxGetApp()->WriteProfileString("his_config", "his_timeStep", buf);
}

CDynaHapticView::~CDynaHapticView(){
}

BOOL CDynaHapticView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDynaHapticView NX̕`

void CDynaHapticView::OnDraw(CDC* pDC){
	CDynaHapticDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	app.Draw();
}
/////////////////////////////////////////////////////////////////////////////
// CDynaHapticView NX̐ff

#ifdef _DEBUG
void CDynaHapticView::AssertValid() const
{
	CView::AssertValid();
}

void CDynaHapticView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDynaHapticDoc* CDynaHapticView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDynaHapticDoc)));
	return (CDynaHapticDoc*)m_pDocument;
}
#endif //_DEBUG

void CDynaHapticView::InitHis(std::string hisList, float ps, float fs){
	app.ClearHis();
	std::istringstream istr(hisList);
	while(istr.good()){
		char line[1024];
		istr.getline(line, sizeof(line));
		app.AddHis(line);
	}
	for(int i=0; i<app.pointers.size(); ++i){
		app.pointers[i]->SetScale(ps, fs);
	}
}

void CDynaHapticView::LoadList(){
	if (fileListCur<0) fileListCur = 0;
	if (fileListCur>=fileList.size()) fileListCur = 0;
	if (fileList.size()){
		DSTR << fileListCur << ": " << fileList[fileListCur].c_str() << std::endl;
		Load(fileList[fileListCur]);
	}
	fileListCur ++;
	if (fileListCur>=fileList.size()) fileListCur = 0;
}
//	t@C̃[h
void CDynaHapticView::Load(std::string fn){
	WBPath path;
	path.Path(fn);
	//	t@CXgt@C̏ꍇ
	if (strcmpi(path.Ext().c_str(), ".lst") == 0){
		std::ifstream fs(fn.c_str());
		while(fs.good()){
			char line[1024];
			fs.getline(line, sizeof(line));
			if (strlen(line)){
				fileList.push_back(line);
			}
		}
		path.SetCwd(path.FullDir());
		fileListCur = 0;
		LoadList();
	//	ʂ̃V[t@C̏ꍇ
	}else{
		if (app.scene) app.scene->SetTimeStep(dlConfig.timeStep);
		app.Load(fn);
		if (app.scene){
			timer.Resolution(app.scene->GetTimeStep()*1000);
			timer.Interval(app.scene->GetTimeStep()*1000);
		}
	}
}

void CDynaHapticView::Save(std::string fn){	//	t@C̃Z[u
	bool bTimerCreated = timer.IsCreated();
	bool bTimerThread = timer.IsThread();
	timer.Release();
	app.Save(fn);
	if (bTimerCreated) timer.Create();
	if (bTimerThread) timer.Thread();
}

/////////////////////////////////////////////////////////////////////////////
// CDynaHapticView NX̃bZ[W nh
void CDynaHapticView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags){
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	switch(nChar){
	case 'P':		//	pause
		timer.Release();
		KillTimer(simuTimerId);
		Step();
		break;
	case 'T':		//	message timer
		timer.Release();
		SetTimer(TIMER_SIMU, simuTimerPeriod*1000, NULL);
		break;
	case 'M':		//	multi media timer		
		if (app.scene){
			timer.Resolution(app.scene->GetTimeStep()*1000);
			timer.Interval(app.scene->GetTimeStep()*1000);
		}
		timer.Create();				//	}`fBA^C}[
		KillTimer(simuTimerId);
		break;
	case 'H':
		timer.Thread();				//	Xbh
		KillTimer(simuTimerId);
		break;
	case VK_RETURN:
		if (fileList.size()){
			LoadList();
		}
		break;
	case '8':	//	ło
		ThrowSphere(0.2f);
		break;
	case '9':
		ThrowSphere(0.3f);
		break;
	case '0':
		ThrowSphere(0.4f);
		break;
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
void CDynaHapticView::ThrowSphere(float r){
	static UTRef<PHSolid> solids[10];
	static int pos=0;
	UTRef<PHSolid> solid = solids[pos];
	if (!solid) solid = new PHSolid;
	solid->SetMass(r*r*20);
	Matrix3f in = Matrix3f::Unit();
	in *= 0.4f* solid->GetMass() *r*r;
	solid->SetInertia(in);

	UTRef<SGFrame> frame = solid->GetFrame();
	UTRef<GRSphere> sphere;
	UTRef<CDSphere> csphere;
	if (frame){
		frame->FindObject(csphere);
		frame->FindObject(sphere);
		frame->Clear();
	}else{
		frame = new SGFrame;
		solid->SetFrame(frame);
	}
	CDCollisionEngine* ce;
	if (app.scene) app.scene->GetBehaviors().Find(ce);
	if (ce){
		SGFrame* frCol = ce->GetFrame(0);
		if (frCol && frCol->GetParent()) frCol->GetParent()->AddChildObject(frame, app.scene);
	}else{
		app.scene->GetWorld()->AddChildObject(frame, app.scene);
	}
	Affinef afSphere = app.mouse->GetAxis().inv();
	afSphere.Ey().X() = 0;
	afSphere.Ey().Z() = 0;
	afSphere.Ey().unitize();
	afSphere.Ex().Y() = 0;
	afSphere.Ex().unitize();
	afSphere.Ez().Y() = 0;
	afSphere.Ez().unitize();
	afSphere.Pos() -= 3*afSphere.Ez();
	frame->SetPosture(afSphere);

	if (!sphere){
		sphere = new GRSphere;
		UTRef<GRMaterial> mat = new GRMaterial;
		mat->diffuse = Vec4f(0, 0.1f, 1.0f, 1.0f);
		mat->specular= Vec4f(0, 0.1f, 1.0f, 1.0f);
		mat->ambient = Vec4f(0, 0.1f, 0.1f, 1.0f);
		mat->emissive= Vec4f(0, 0.1f, 0.1f, 1.0f);
		sphere->AddChildObject(mat, app.scene);
	}
	sphere->radius = r;
	sphere->slices = 16;
	sphere->stacks = 8;
	frame->AddChildObject(sphere, app.scene);
	app.render->InitTree(frame, app.scene);

	if (!csphere) csphere = new CDSphere;
	csphere->radius = r;
	csphere->pmaterial = new PHPhysicalMaterial;
	csphere->pmaterial->pMatData.reflexDamper = 0.1f;
	csphere->pmaterial->pMatData.reflexSpring = 1.0f;
	frame->AddChildObject(csphere, app.scene);
	frame->CalcBBox();

	PHSolidContainer* sc;
	app.scene->GetBehaviors().Find(sc);
	if (sc && !sc->solids.Find(solid)) sc->AddChildObject(solid, app.scene);
	PHGravityEngine* ge;
	app.scene->GetBehaviors().Find(ge);
	if (ge && !ge->solids.Find(solid)) ge->AddChildObject(solid, app.scene);

	solid->SetVelocity(-afSphere.Ez() * 8.0f);
	solid->SetAngularVelocity(Vec3f());

	PHContactEngine* pce;
	app.scene->GetBehaviors().Find(pce);
	if (pce && !pce->solids.Find(solid)){
		pce->AddChildObject(solid, app.scene);
		pce->Init(app.scene);
	}
	solids[pos] = solid;
	pos++;
	if (pos >= 10) pos = 0;
}

BOOL CDynaHapticView::OnEraseBkgnd(CDC* pDC) 
{
	// MFC̓ftHgŔwi𔒂hD̂ŉȂ֐ŃI[o[ChD
	return true;
}

///	}`fBA^C}[ɌĂяo֐
void TimerFunc(void* arg){
	CDynaHapticView* view = (CDynaHapticView*) arg;
	view->Step();
}

void CDynaHapticView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	app.Init(m_hWnd);
	//	`p^C}[̐ݒ
	drawTimerId = SetTimer(TIMER_DRAW, 33, NULL);
	//	V~[Vp̕ʂ̃^C}[̐ݒ
	simuTimerId = SetTimer(TIMER_SIMU, simuTimerPeriod*1000, NULL);
	//	V~[Vp̃}`fBA^C}[̐ݒ
	timer.Set(TimerFunc, this);
}

//	^C}[ɌĂ΂֐DV~[VƗ͊o񎦂sD
void CDynaHapticView::Step(){
	//	ŃV~[ṼXebvׂĎsĂD
	//	SGBehaviorEngine ̔hIuWFNgԂɌĂ΂ăV~[VsD
	detectTime = 0;
	analyzeTime = 0;
	refTime = 0;
	fricTime = 0;
	totalTime = 0;
	static WBPreciseTimer ptimer;
	ptimer.CountUS();
	app.Step();
	totalTime = ptimer.CountUS();
}

void CDynaHapticView::OnTimer(UINT nIDEvent){
	if (nIDEvent == TIMER_SIMU){
		int times = 1;
		if (app.scene){
			times = simuTimerPeriod / app.scene->GetTimeStep();
		}
		for(int i=0; i<times; ++i) Step();
	}else if (nIDEvent == TIMER_DRAW){
		Invalidate();
	}
}

void CDynaHapticView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	timer.Release();
}

void CDynaHapticView::OnD3d(){
	app.CreateD3DRender();
}

void CDynaHapticView::OnGL(){
	app.CreateGLRender();
}

BOOL CDynaHapticView::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	app.PreviewMessage(pMsg);
	return CView::PreTranslateMessage(pMsg);
}

void CDynaHapticView::OnHisConfig(){
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	ReadRegistry();
	if (dlConfig.DoModal() == IDOK){
		WriteRegistry();
		InitHis(std::string(dlConfig.hisList), dlConfig.posScale, dlConfig.forceScale);
		if (app.scene) app.scene->SetTimeStep(dlConfig.timeStep);
		app.ConnectHis();
		timer.Resolution(dlConfig.timeStep*1000);
		timer.Interval(dlConfig.timeStep*1000);
	}
}



