#include "Framework.h"
#include "GraphicsGL/GLRenderWgl.h"
#include "ImpD3D/D3Render.h"
#include <Device/DRUsb20Simple.h>
#include <Device/DRUsb20Sh4.h>
#include <HIS/HISpidar4.h>
//JEONG
#include <HIS/HISpidar4Angers.h>
#include <HIS/HISpidarG6C.h>
#include <HIS/HISpidarG6O.h>
#include <HIS/HISpidarG6X.h>
#include <HIS/HISpidarG6WB.h>
#include <HIS/HISpidarG6Jun.h>
#include <Physics/PHContactEngine.h>
#include <strstream>
#pragma hdrstop

namespace Spr{;
FWApp::FWApp(){
	hWnd = NULL;
	bOutForce = false;
	bBusy = false;
	InitDevice();
}
FWApp::~FWApp(){
	pointers.clear();
}
void FWApp::InitDevice(){
	mouse = new HIMouse;
	devMan.Clear();
	devMan.RPool().Register(new DRUsb20Sh4(0));
	devMan.RPool().Register(new DRUsb20Sh4(1));
	devMan.RPool().Register(new DRUsb20Sh4(2));
	devMan.RPool().Register(new DRUsb20Sh4(3));
	devMan.RPool().Register(new DRUsb20Sh4(4));
	devMan.RPool().Register(new DRUsb20Sh4(5));
	devMan.RPool().Register(new DRUsb20Simple(10));
	devMan.RPool().Register(new DRUsb20Simple(11));
	devMan.Init();
	DSTR << devMan;
}
void FWApp::Init(HWND hw){
	hWnd = hw;
	if (initialLoadFile.length()){
		lastLoadFile = initialLoadFile;
		initialLoadFile = "";
	}
	if (!scene) scene = new SGScene;
	CreateD3DRender();
}
#define IF_SPIDAR(t)										\
		if (strcmp(t::GetTypeStatic(), type) == 0){			\
			UTRef<t> dev = new t;							\
			if (dev->Init(devMan)){							\
				pointers.push_back(new FWPointer6D(dev));	\
				rv = true;									\
			}												\
		}

bool FWApp::AddHis(const char* str){
	bBusy = true;
	cs.Enter();
	bool rv = true;
	std::istrstream is(str, strlen(str));
	char type[100];
	is >> type;
	HIForceDevice6D* dev=NULL;
	if (strcmp(HIMouse::GetTypeStatic(), type) == 0){
		if (!mouse->IsGood()){
			mouse->Init();
			pointers.push_back(new FWPointer6D(mouse));
			rv = true;
		}
	}else if (strcmp(HISpidar4::GetTypeStatic(), type) == 0){

		//	Spidar4̏l
		#define PX	0.265f	//	EN length of the x side of the frame /2
		#define PY	0.265f	//	EN length of the y side of the frame /2
		#define PZ	0.265f	//	EN length of the z side of the frame /2
		Vec3f motorPos[4] = {	//JA	[^̎tʒu(S_Ƃ)
								//EN	Motor's position (origin is calibration position)
			Vec3f(PX, PY, PZ),	Vec3f(-PX, PY,-PZ), Vec3f(PX,-PY,-PZ), Vec3f(-PX,-PY, PZ)
		};
		Vec3f frame(PX, PY, PZ);
		float minForce = 0.5f;
		float maxForce = 20.0f;
		float vpn = 0.3776f;
		float lpp = 2.924062107079e-5f;
		while(is.good()){
			char argType[100];
			is >> argType;
			if (stricmp(argType, "frame")==0){
				is >> frame.X() >> frame.Y() >> frame.Z();
			}else if (stricmp(argType, "motor")==0){
				for(int i=0; i<4; ++i){
					for(int j=0; j<3; ++j){
						char ch;
						is >> ch;
						if (ch == '-'){
							motorPos[i][j] = -frame[j]/2;
						}else{
							motorPos[i][j] = frame[j]/2;
						}
					}
				}
			}else if (stricmp(argType, "range")==0){
				is >> minForce;
				is >> maxForce;
			}else if (stricmp(argType, "vpn")==0){
				is >> vpn;
			}else if (stricmp(argType, "lpp")==0){
				is >> lpp;
			}else if (stricmp(argType, "reverse")==0){		//	ЂԂ
				for(int i=0; i<4; ++i) motorPos[i].X()*=-1;
				lpp *= -1;
			}
		}
		UTRef<HISpidar4> spidar = new HISpidar4;
		if (spidar->Init(devMan, motorPos, vpn, lpp, minForce, maxForce)){
			pointers.push_back(new FWPointer6D(spidar));
			rv = true;
		}
	}
	else if (strcmp(HISpidar4Angers::GetTypeStatic(), type) == 0)
	{
		
		float minForce = 0.5f;
		float maxForce = 10.0f;
		float vpn = 0.3776f;
		float lpp = 2.924062107079e-5f;
		
		Vec3f motorPos[][4] = {	//	
		{Vec3f( 1.145f, 1.45f, 1.14f),	Vec3f(-1.14f, 1.45f,-1.155f), Vec3f( 1.145f,-1.30f,-1.155f), Vec3f(-1.14f,-1.30f, 1.14f)},
		{Vec3f(-1.14f, 1.45f, 1.14f),	Vec3f( 1.14f, 1.45f,-1.155f), Vec3f(-1.14f,-1.30f,-1.155f), Vec3f( 1.145f,-1.30f, 1.14f)}
		};    
	
		for(int i=0; i<4; ++i) motorPos[1][i].X()*=-1;
	 
	
		UTRef<HISpidar4Angers> spidar = new HISpidar4Angers;
	
		if (spidar->Init(devMan, motorPos[0], vpn, lpp, minForce, maxForce))
		{
			pointers.push_back(new FWPointer6D(spidar));
			rv = true;
		}

		UTRef<HISpidar4Angers> spidar1 = new HISpidar4Angers;
		if (spidar1->Init(devMan, motorPos[1], vpn, lpp, minForce, maxForce))
		//if (spidar1->Init(devMan, 1))
		{
			pointers.push_back(new FWPointer6D(spidar1));
			rv = true;
		}

	}

	else IF_SPIDAR(HISpidarG6C)
	else IF_SPIDAR(HISpidarG6O)
	else IF_SPIDAR(HISpidarG6X)
	else IF_SPIDAR(HISpidarG6WB)
	else IF_SPIDAR(HISpidarG6Jun)
	bBusy = false;
	cs.Leave();
	return rv;
}
void FWApp::ClearHis(){
	bBusy = true;
	cs.Enter();
	pointers.clear();
	InitDevice();
	cs.Leave();
	bBusy = false;
}
void FWApp::ConnectHis(){
	pointers.Connect(scene);

	FWPointer6D* pMouse = (FWPointer6D*) pointers.Find(mouse);
	if (pMouse && pMouse->GetSolid()){
		// }EXfoCX̐ݒ
		mouse->SetMass((float)pMouse->GetSolid()->GetMass());
	}
	mouse->SetAxis(render->camera->data.view);
	mouse->SetAxisInit(render->camera->data.view);

}
bool FWApp::PreviewMessage(MSG* pMsg){
	bool rv = false;
	rv |= mouse->PreviewMessage(pMsg);
	if (mouse->IsGood()){
		for(FWPointers::iterator it = pointers.begin(); it != pointers.end(); ++it){
			if ((*it)->device == mouse){
				(*it)->Step(scene->GetTimeStep());
				break;
			}
		}
		// J}EX̊WɍXV
		if (render && render->camera) render->camera->data.view = mouse->GetAxis();
	}
	if (pMsg->message == WM_KEYDOWN){
		int nVirtKey = (int) pMsg->wParam;
		long lKeyData = pMsg->lParam;
		rv |= OnKeyDown(nVirtKey);
	}
	return rv;
}

void FWApp::Step(){
	if (bBusy) return;
	cs.Enter();
	scene->Step();
	pointers.Step(scene->GetTimeStep());
	cs.Leave();
}

void FWApp::Reset(){
    Load(lastLoadFile);
    return;
}

bool FWApp::OnKeyDown(unsigned int nChar){
	//	L[
	//	_ړ HIMouse sD
	if ( nChar == 'R' ){			//	[h
		Reset();
	}else if ( nChar == VK_SPACE ){
		bOutForce = !bOutForce;
		for(int i=0; i<pointers.size(); ++i){
			pointers[i]->SetOutForce(bOutForce);
		}
	}else if ( nChar == 'C'){
		for(int i=0; i<pointers.size(); ++i){
			if (pointers[i]->device){
				pointers[i]->device->Calib();
			}
		}
	}else if ( nChar == 'F' ){
		render->Fullscreen();
	}else if ( nChar == 'G' ){
		render->Window();
	}else if ( nChar == ',' ){
		if (scene->GetTimeStep() > 0.01) scene->SetTimeStep(scene->GetTimeStep() - 0.01);
		else scene->SetTimeStep(scene->GetTimeStep() - 0.001);
		DSTR << "dt:" << scene->GetTimeStep() << std::endl;
	}else if ( nChar == '.' ){
		if (scene->GetTimeStep() > 0.01) scene->SetTimeStep(scene->GetTimeStep() + 0.01);
		else scene->SetTimeStep(scene->GetTimeStep() + 0.001);
		DSTR << "dt:" << scene->GetTimeStep() << std::endl;
	}else if ( nChar == 'D' ){
		PHContactEngine* pce;
		scene->GetBehaviors().Find(pce);
		if (pce) pce->bDraw = !pce->bDraw;
	}else{
		return false;
	}
	return true;
}
void FWApp::Draw(){
	if (!render) return;
	render->Render(scene);			//	V[̕`
	render->EndScene();				//	`I
	render->Present();				//	\
	render->SetViewport(hWnd);	//	Viewport̐ݒ
	render->ClearBuffer();			//	obt@NA
	render->BeginScene();			//	`Jn
}
void FWApp::CreateD3DRender(){
	if (render) render->EndScene();
	render = new D3Render;
	render->Create(hWnd);
	render->BeginScene();
	if (lastLoadFile.length()) Load(lastLoadFile.c_str());
}
void FWApp::CreateGLRender(){
	if (render) render->EndScene();
	render = new GLRenderWgl;
	render->Create(hWnd);	
	render->BeginScene();
	Load(lastLoadFile.c_str());
}


}

