#ifndef FWAPP_H
#define FWAPP_H
#include "FWPointer.h"
#include <SceneGraph/SGScene.h>
#include <Graphics/GRRender.h>
#include <HIS/HIMouse.h>
#include <Device/DVDeviceManager.h>
#include <WinBasis/WBCriticalSection.h>

namespace Spr{;

class FWApp{
protected:
	UTString initialLoadFile;
	UTString lastLoadFile;
	HWND hWnd;
	bool bOutForce;
	volatile bool bBusy;
	WBCriticalSection cs;
public:
	UTRef<SGScene> scene;
	UTRef<GRRender> render; 
	FWPointers pointers;
	UTRef<HIMouse> mouse;
	DVDeviceManager devMan;

	FWApp();
	virtual ~FWApp();

	void InitDevice();
	virtual void Init(HWND hWnd);
	virtual void Step();
	virtual bool AddHis(const char* type);
	virtual void ClearHis();
	virtual void ConnectHis();

	virtual bool PreviewMessage(MSG* pMsg);

	virtual void Draw();
	virtual void CreateD3DRender();
	virtual void CreateGLRender();
	virtual void Load(UTString fn){}
	virtual void Save(UTString fn){}
	virtual bool OnKeyDown(unsigned int key);
	virtual void Reset();
};

}
#endif
