#ifndef VR_HAPTIC_HDHAPTIC_H
#define VR_HAPTIC_HDHAPTIC_H
#include <Base/Env.h>
#include <Base/Affine.h>
#include <Base/BaseUtility.h>
#include <set>

namespace Spr {
class DRRealDevice;


#pragma warning(disable:4275)
#pragma warning(disable:4251)

//----------------------------------------------------------------------------
//	HIHapticDevice
#define HI_DEVICE_TYPE_DEF(x)	\
static const char* GetTypeStatic(){ return x; }	\
virtual  const char* GetType(){ return x; }


///	͊o񎦑ůNX
class SPR_DLL HIHapticDevice: public UTRefCount{
protected:
	static std::set<DRRealDevice*> realDevices;
	static int deviceUpdateStep;
	int updateStep;
	bool bGood;
public:
	/**@name	Ȃ	*/
	//@{
	/// 
	HIHapticDevice(){ updateStep = deviceUpdateStep; bGood=false;}
	virtual ~HIHapticDevice(){}
	///	Lu[V̑Oɍs
	virtual bool BeforeCalib(){ return true; }
	///	Lu[V
	virtual bool Calib(){ return true; }
	///	Lu[V̂Ƃɍs
	virtual bool AfterCalib(){ return true; }
	///
	void AddRealDeviceDependency(DRRealDevice* rd);
	//@}
	/**	foCX̏ԂXVD	*/
	virtual void Update(float dt);
	///	
	bool IsGood(){ return bGood; }
	///	foCX̃^Cv
	HI_DEVICE_TYPE_DEF("HapticDevice")
};

//----------------------------------------------------------------------------
//	HIForceDevice3D

///	i]6Rx̃foCX
class SPR_DLL HIForceDevice6D: public HIHapticDevice{
protected:
	float alpha;
	Vec3f vel, angVel;
	Vec3f lastPos;
	Quaternionf lastOri;
public:
	///
	HIForceDevice6D();
	///
	virtual ~HIForceDevice6D(){}
	virtual void Update(float dt);

	/**@name	foCX̏	*/
	//@{
	///	foCX݈̌ʒuԂ
	virtual Vec3f GetPos()=0;
	///	foCX̌Ԃ
	virtual Quaternionf GetOri()=0;
	///	foCX̑xԂ
	virtual Vec3f GetVel(){ return vel; }
	///	foCX̊pxԂ
	virtual Vec3f GetAngVel(){ return angVel; }
	///	foCX̎ۂ̒񎦃gNԂ
	virtual Vec3f GetTorque()=0;
	///	foCX̎ۂ̒񎦗͂Ԃ
	virtual Vec3f GetForce()=0;
	///	foCX̖ڕWo͂ƃgNo͂ݒ肷
	virtual void SetForce(const Vec3f& f, const Vec3f& t)=0;
	//@}
};

/*class SPR_DLL HIForceDevice3DPlus: public HIForceDevice3D{
	virtual Vec3f GetRot()=0;
};
*/

//----------------------------------------------------------------------------
//	HIForceDevice3D
///	i3Rx̃foCX
class SPR_DLL HIForceDevice3D: public HIForceDevice6D{
public:
	///	foCX̖ڕW͏o͂ݒ肷
	virtual void SetForce(const Vec3f& f)=0;
	virtual void SetForce(const Vec3f& f, const Vec3f& t){ SetForce(f); }
	///	foCX̎ۂ̒񎦃gNԂ
	virtual Vec3f GetTorque(){ return Vec3f(); }
	virtual Quaternionf GetOri(){ return Quaternionf(); } 
};

//----------------------------------------------------------------------------
//	HIForceDevice7D
///	7Rx̃foCX
class SPR_DLL HIForceDevice7D: public HIForceDevice6D{
public:
	virtual ~HIForceDevice7D(){}
	///	foCX̔cԂ
	virtual float GetGap()=0;
	///	foCX̒񎦔c͂Ԃ
	virtual float GetGrasp()=0;
	///	foCX̖ڕW͔c͂ݒ肷
	virtual void SetGrasp(float g)=0;
};

}	//	namespace Spr
#endif
