#include "HIS.h"
#pragma hdrstop
#include "HISpidar4Angers.h"

namespace Spr {;
//----------------------------------------------------------------------------
HISpidar4Angers::HISpidar4Angers() : HISpidar4() {
}

bool HISpidar4Angers::InitSet(DVDeviceManager& dev, int CounterInverse)
{

// 2004.12 NEW SETTING for angers univ. central point 130cm from floor
	Vec3f motorPos[][4] = {	//	[^̎tʒu(S_Ƃ)
		{Vec3f( 1.145f, 1.45f, 1.14f),	Vec3f(-1.14f, 1.45f,-1.155f), Vec3f( 1.145f,-1.30f,-1.155f), Vec3f(-1.14f,-1.30f, 1.14f)},
		{Vec3f(-1.14f, 1.45f, 1.14f),	Vec3f( 1.14f, 1.45f,-1.155f), Vec3f(-1.14f,-1.30f,-1.155f), Vec3f( 1.145f,-1.30f, 1.14f)}
		};


	if( HISpidar4::Init(dev, motorPos[0], 0.3776f, 2.924062107079e-5f, 0.5f, 20.0f) == false ){
		return false;
	}
	if( HISpidar4::Init(dev, motorPos[1], 0.3776f, 2.924062107079e-5f, 0.5f, 20.0f) == false ){
		return false;
	}
  
	if (CounterInverse)
	{
		//right inverse
		for(int i=0; i<4; ++i){
		motor[i].lengthPerPulse *= -1;
		}
	
	}

//	HISpidar4::Calib();
	return true;
}

}//	namespace Spr