#ifndef VR_HAPTIC_HDSPIDARMOTOR_H
#define VR_HAPTIC_HDSPIDARMOTOR_H

#include "Base/Affine.h"
#include "Device/DVDaBase.h"
#include "Device/DVCounterBase.h"

namespace Spr {

class SPR_DLL HISpidarMotor{
public:
	///	őo(N)
	float maxForce;
	///	ŏo(N)
	float minForce;
	///	D/Ȁo / d  (V/N)
	float voltPerNewton;
	///	̒ / pX
	float lengthPerPulse;
	///őó|ŏo
	float tLimit;
	///	gpD/A.
	DVDaBase* da;
	///	gpGR[_̃JE^.
	DVCounterBase* counter;
	///	[^tĂʒu(̏o)̍W
	Vec3f pos;
	///	ObvɎtĂʒu
	Vec3f jointPos;

public:
	///	
	HISpidarMotor();
	///	
	virtual ~HISpidarMotor(){}
	///	o͂̐ݒ
	void SetForce(float f){
		if(f < minForce) f = minForce;
		if(f > maxForce) f = maxForce;
		if(da) da->Voltage(f * voltPerNewton); 
	}
	///	݂̎̒̐ݒ
	void SetLength(float l){ if(counter) counter->Count(long(l / lengthPerPulse)); }
	///	݂̎̒
	float GetLength(){
		if(counter) return counter->Count() * lengthPerPulse;
		else return 0;
	}
};

}	//	namespace Spr
#endif
