#include "His/HISpidar4.h"
//	USB2.0AṽhCo
// USB2.0 controller drivers
#include <Device/DRUsb20Simple.h>
#include <Device/DRUsb20Sh4.h>
//	ContectISAJ[h̃hCoDÂ(1997-)D
//EN old version Drivers of ISA card
//#include "Device/DRContecIsaDa.h"
//#include "Device/DRContecIsaCounter.h"
//#include <Device/DRUsbH8Simple.h>

#include <conio.h>
#include <iostream>

using namespace Spr;	//	SprSpringheadCu̖O
//EN Spr is namespace of springhead library

void main(){
	//------------------------------------------------------------------------
	//	
	// EN initialize part
	DVDeviceManager devMan;		//	foCXhCoĂꕨ
	devMan.RPool().Register(new DRUsb20Simple(10));	//	USB2.0Av(ID 10)o^ 
	//EN Register ID of USB2.0 AMP.
	devMan.RPool().Register(new DRUsb20Sh4(0));		//	SH4Av(ID 0)o^
	//EN Register ID(0) of SH4 controller
	/*	gĂȂhCoDo^ĂΎFD
	devMan.RPool().Register(new DRUsbH8Simple(0));
	devMan.RPool().Register(new DRContecIsaDa(0x300));
	devMan.RPool().Register(new DRContecIsaCounter(0x200));
	devMan.RPool().Register(new DRContecIsaCounter(0x210));
	*/
	/*	hCȍD݂foCXɑΉo[`foCX
		ŏ	*/
	// EN Initialize of Virtual Drivers. These are correspond to real devices. 
	devMan.Init();
	std::cout << devMan;	//	foCX̏Ԃ̕\
	// EN Debug (display)  status of device

	HISpidar4 spidar;
	HISpidar4 spidar2;

	//	SPIDAȐD{́Cn[hEGA HISpidar4 NXhׂ
	//	[^̎tʒu. [^̂ɎtĂꍇ́C
	// EN Initialize of SPIDAR. In fact, this should have define subclass of HISpidar4
	// EN define setup position of each motor. In the case, we suppose the workspace of spidar is a cubic frame.
	#define PX	0.265f	//	x̕ӂ̒/2
	#define PY	0.265f	//	y̕ӂ̒/2
	#define PZ	0.265f	//	z̕ӂ̒/2
	Vec3f motorPos[][4] = {	//	[^̎tʒu(S_Ƃ)
		{Vec3f(-PX, PY, PZ),	Vec3f( PX, PY,-PZ), Vec3f(-PX,-PY,-PZ), Vec3f( PX,-PY, PZ)},
		{Vec3f( PX, PY, PZ),	Vec3f(-PX, PY,-PZ), Vec3f( PX,-PY,-PZ), Vec3f(-PX,-PY, PZ)}
	};
	spidar.Init(devMan, motorPos[0], 0.3776f, 2.924062107079e-5f, 0.5f, 20.0f);
	spidar2.Init(devMan, motorPos[1], 0.3776f, -2.924062107079e-5f, 0.5f, 20.0f);
	
	

	//------------------------------------------------------------------------
	//	C[v
	//  EN main loop
	bool bMinForce = true;	//	Ȃ͂oƊ댯Ȃ̂ŁCXy[X܂ł͍ŏ͂o
//EN When the force is diplayed suddenly, it is not good, so you should be set a minimum force at first
	while(1){
		if (kbhit()){		//	L[  EN: input keycode
			int ch = getch();
			switch(ch){
			case ' ':		//	Xy[XF͊oON/OFF // Space key : force on/off
				bMinForce = !bMinForce;
				break;
			case 0x1b:		//	ESC:I  //EN: close esc key
				goto end;
				break;
			}
		}
		//------------------------------------------------------------------------
//			static float pos_x_buf1=0,pos_x_buf2=0,pos_x_buf3=0;

		//------------------------------------------------------------------------

		spidar.Update(0.01f);				//	AvƂ̒ʐM(͂񎦁Eʒu擾)
		//EN: for getting a position and diplaying a force, to communicate with the controller
		Vec3f force;					//	񎦂 //EN: the displayed force

		spidar.Calib();                 //calibration
/*
		const float K = 2000.0f;		//	΂˒萔 F=-kx  spring constant
		if (spidar.GetPos().Y() < 0){	//	̒  display a floor
			force.Y() = - K * spidar.GetPos().Y();
		}
		if (force.norm() > 10){			//	傫͂͒񎦂łȂ̂ŁC10Nɐ
		//EN: to contraint the displayed force, 10N
			force = force.unit() * 10;
		}*/
		//------------------------------------------------------------------------
/*			pos_x_buf3=pos_x_buf2;
			pos_x_buf2=pos_x_buf1;
			pos_x_buf1=spidar.GetPos().X();
			std::cout << "1:" << pos_x_buf1 << "\t2:" << pos_x_buf2 << "\t3:" << pos_x_buf3 << std::endl;

			force.X() = -5.0f*pos_x_buf2-pos_x_buf1-pos_x_buf3;
*/		//------------------------------------------------------------------------
		//	񎦗͂̐ݒ  //EN: setting a force
		if (bMinForce) spidar.SetMinForce();  //set a minimum force
		else spidar.SetForce(force);

		//	ȉ2ԖڂSPIDARɂēlɁC
		// other hand setting is the same as descibed above 
		Vec3f force2;
		spidar2.Update(0.01f);//0.001f
		/*
		if (spidar2.GetPos().Y() < 0){
			force2.Y() = - K * spidar2.GetPos().Y();
		}
		if (bMinForce) spidar2.SetMinForce();
		else spidar2.SetForce(force2);
		*/

	
		//	fobOpFʒuƗ͂\
		//EN: for deug, print out the positions and force
//		std::cout << "P:" << spidar.GetPos() << "\tF:" << spidar.GetForce() << std::endl;

		//	fobOpF̒\  EN: print out length of wire 
/*
		for(int i=0; i<4; i++){
			std::cout << spidar.Motor()[i].GetLength() << " ";
		}
		for(int i=0; i<4; i++){
			std::cout << spidar2.Motor()[i].GetLength() << " ";
		}
		std::cout << std::endl;
*/
} 
end:;
}
